structure Translate = 
struct
  (*  fresh () ==> a string which has not previously been returned by this
   *  function, and which could not have appeared in the source program.
   *)
  local
    val c = ref 0
  in
    fun fresh () = (
      c := !c + 1;
      "%" ^ Int.toString (!c)
    )
  end

  structure LPP = LambdaPlusPlus
  structure LC = LambdaCalculus
  val ` = LC.Variable

  (* a few popular combinators in LC, for convenience *)
  local
    val (x, y) = (fresh (), fresh ())
  in
    val K = LC.Lambda (x, LC.Lambda (y, `x))
    val I = LC.Lambda (x, `x)
    val K' = LC.Lambda (x, I)
    val Y = LC.Lambda (x, LC.Apply (
      LC.Lambda (y, LC.Apply (`x, LC.Apply (`y, `y))),
      LC.Lambda (y, LC.Apply (`x, LC.Apply (`y, `y)))
    ))
  end


  val rec translate = (fn _ => `"unimplemented")
  
end